import React, {useState, useEffect, useRef} from 'react';

import {
   Header, 
   CChatMngHeader,
   CMsgList,
   CSendingField,   
} from "../components"

import {
   actionFullMsgsByChat,
 } from "../actions"
 import {
   actionChatOne
 } from "../reducers"
 import { connect } from 'react-redux'
import { Repeat } from '@mui/icons-material';



const msgPageContainer = {
   backgroundColor: '#eee',
   height: "100vh",
   width: "100%"
}
const msgPageHeader = {
   height: "60px"
}
const msgPageBody = {
   height: "calc(100vh - 60px)",
   display: "flex",
   flexDirection: "column",
   justifyContent: "space-between"
}

const msgs = {
   flexGrow: 1,
   overflowY: "auto",
   display: "flex",
   flexDirection: "column-reverse",
}
const msgSend = {
   flexGrow: 0,
   height: "max-content",
   maxHeight: "60%",
}


 

const MsgBlock = ({ chatId, scroll, setScroll, getMsgs, setLastVizited, msgsCount=20 }) => {

   const [msgToEdit, setmMsgToEdit] = useState()

   const [msgsBlock, setMsgsBlock] = useState(0)

   // перезагрузка и обновление стейта происходит тут ??????????
   // надо как то отлавливать первый не первый рендер ????????

   const divRef = useRef(null)
   // useEffect(() => {
   //    divRef.current.scrollTop = scroll[chatId]
   //    console.log(scroll)
   // },[scroll])


   useEffect(() => {
      getMsgs(chatId, msgsBlock, msgsCount)
   },[msgsBlock])

   // useEffect(() => {
   //    return () => {
   //       setLastVizited({
   //             _id: chatId, 
   //             // lastVizited: (Math.ceil((new Date()).getTime()/1000).toString(16) + '0'.repeat(16) )
   //             lastVizited: (new Date()).getTime()
   //          }
   //       )  
   //    }
   // },)

   return (
      <>  
         <div style={msgPageContainer}>

            <div style={msgPageHeader}>
               <Header> 

                  <CChatMngHeader chatId={chatId} />

               </Header>  
            </div>

            <div style={msgPageBody}>

               <div 
                  style={msgs}
                  ref={divRef}
                  onScroll={(e) => {
                     // setScroll({...scroll, [chatId]: e.target.scrollTop})

                     if (e.target.scrollTop*(-1) >= e.target.scrollHeight - e.target.clientHeight) {
                        setMsgsBlock(msgsBlock => msgsBlock + msgsCount)
                     }
                  }}
                  >
                  <CMsgList chatId={chatId} onEdit={setmMsgToEdit} />
               </div>

               <div style={msgSend}>
                  <CSendingField chatId={chatId} msg={msgToEdit} />
               </div>       

            </div>

         </div>              
      </>
   )
}
const CMsgBlock = connect( null, {getMsgs: actionFullMsgsByChat, setLastVizited: actionChatOne })(MsgBlock)


export const MsgPage = ({ match:{params:{_id}} }) => {

   const [scroll, setScroll] = useState({})

   return (
      <>
         <CMsgBlock chatId={_id} scroll={scroll} setScroll={setScroll} key={_id} />
      </>
   )
}
